<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">

<html lang="en">
<head>

<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">

<meta name="generator" content="PHPDoctor 2RC4 (http://peej.github.com/phpdoctor/)">
<meta name="when" content="Fri, 15 Apr 2011 16:43:07 +0000">

<link rel="stylesheet" type="text/css" href="../../stylesheet.css">
<link rel="start" href="../../overview-summary.html">

<title>classes/seeTag.php (PHPDoctor)</title>

</head>
<body id="file" onload="parent.document.title=document.title;">

<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../overview-files.html">Files</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../todo-list.html">Todo</a></li>
<li><a href="../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../index.html" target="_top">Frames</a>
<a href="../../source/classes/seetag.php.html" target="_top">No frames</a>
</div>
<hr>

<h1>classes/seeTag.php</h1>
<hr>

<a name="line1"></a><pre><?php
<a name="line2"></a>/*
<a name="line3"></a>PHPDoctor: The PHP Documentation Creator
<a name="line4"></a>Copyright (C) 2004 Paul James <paul@peej.co.uk>
<a name="line5"></a>
<a name="line6"></a>This program is free software; you can redistribute it and/or modify
<a name="line7"></a>it under the terms of the GNU General Public License as published by
<a name="line8"></a>the Free Software Foundation; either version 2 of the License, or
<a name="line9"></a>(at your option) any later version.
<a name="line10"></a>
<a name="line11"></a>This program is distributed in the hope that it will be useful,
<a name="line12"></a>but WITHOUT ANY WARRANTY; without even the implied warranty of
<a name="line13"></a>MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
<a name="line14"></a>GNU General Public License for more details.
<a name="line15"></a>
<a name="line16"></a>You should have received a copy of the GNU General Public License
<a name="line17"></a>along with this program; if not, write to the Free Software
<a name="line18"></a>Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
<a name="line19"></a>*/
<a name="line20"></a>
<a name="line21"></a>/** Represents a see tag.
<a name="line22"></a> *
<a name="line23"></a> * @package PHPDoctor\Tags
<a name="line24"></a> */
<a name="line25"></a>class SeeTag extends Tag
<a name="line26"></a>{
<a name="line27"></a>
<a name="line28"></a>	/** The link.
<a name="line29"></a>	 *
<a name="line30"></a>	 * @var str
<a name="line31"></a>	 */
<a name="line32"></a>	var $_link = NULL;
<a name="line33"></a>
<a name="line34"></a>	/**
<a name="line35"></a>	 * Constructor
<a name="line36"></a>	 *
<a name="line37"></a>	 * @param str text The contents of the tag
<a name="line38"></a>	 * @param str[] data Reference to doc comment data array
<a name="line39"></a>	 * @param RootDoc root The root object
<a name="line40"></a>	 */
<a name="line41"></a>	function seeTag($text, &$data, &$root)
<a name="line42"></a>    {
<a name="line43"></a>		if (preg_match('/^<a href="(.+)">(.+)<\/a>$/', $text, $matches)) {
<a name="line44"></a>			$this->_link = $matches[1];
<a name="line45"></a>			$text = $matches[2];
<a name="line46"></a>		} elseif (preg_match('/^([^ ]+)([ \t](.*))?$/', $text, $matches)) {
<a name="line47"></a>			$this->_link = $matches[1];
<a name="line48"></a>			if (isset($matches[3])) {
<a name="line49"></a>				$text = $matches[3];
<a name="line50"></a>			}
<a name="line51"></a>		} else {
<a name="line52"></a>			$this->_link = NULL;
<a name="line53"></a>		}
<a name="line54"></a>		parent::tag('@see', $text, $root);
<a name="line55"></a>	}
<a name="line56"></a>	
<a name="line57"></a>	/** Get display name of this tag.
<a name="line58"></a>	 *
<a name="line59"></a>	 * @return str
<a name="line60"></a>	 */
<a name="line61"></a>	function displayName()
<a name="line62"></a>    {
<a name="line63"></a>		return 'See Also';
<a name="line64"></a>	}
<a name="line65"></a>	
<a name="line66"></a>	/** Get value of this tag.
<a name="line67"></a>	 *
<a name="line68"></a>	 * @param Doclet doclet
<a name="line69"></a>	 * @return str
<a name="line70"></a>	 */
<a name="line71"></a>	function text($doclet)
<a name="line72"></a>    {
<a name="line73"></a>        $link = parent::text($doclet);
<a name="line74"></a>		if (!$link || $link == "\n") {
<a name="line75"></a>			$link = $this->_link;
<a name="line76"></a>		}
<a name="line77"></a>		return $this->_linkText($link, $doclet);
<a name="line78"></a>	}
<a name="line79"></a>	
<a name="line80"></a>	/**
<a name="line81"></a>	 * Generate the text to go into the seeTag link
<a name="line82"></a>	 *
<a name="line83"></a>	 * @param str link
<a name="line84"></a>	 * @param Doclet doclet
<a name="line85"></a>	 */
<a name="line86"></a>	function _linkText($link, $doclet) {
<a name="line87"></a>	    $element =& $this->_resolveLink();
<a name="line88"></a>		if ($element && $this->_parent) {
<a name="line89"></a>			$package =& $this->_parent->containingPackage();
<a name="line90"></a>			$path = str_repeat('../', $package->depth() + 1).$element->asPath();
<a name="line91"></a>			return $doclet->formatLink($path, $link);
<a name="line92"></a>		} elseif (preg_match('/^(https?|ftp):\/\//', $this->_link) === 1) {
<a name="line93"></a>			return $doclet->formatLink($this->_link, $link);
<a name="line94"></a>		} else {
<a name="line95"></a>			return $link;
<a name="line96"></a>		}
<a name="line97"></a>	}
<a name="line98"></a>	
<a name="line99"></a>	/**
<a name="line100"></a>	 * Turn the objects link text into a link to the element it refers to.
<a name="line101"></a>	 *
<a name="line102"></a>	 * @return ProgramElementDoc
<a name="line103"></a>	 */
<a name="line104"></a>	function &_resolveLink()
<a name="line105"></a>    {
<a name="line106"></a>		$phpdoctor = $this->_root->phpdoctor();
<a name="line107"></a>		$matches = array();
<a name="line108"></a>        $return = NULL;
<a name="line109"></a>		$packageRegex = '[a-zA-Z0-9_\x7f-\xff .\\\\-]+';
<a name="line110"></a>		$labelRegex = '[a-zA-Z_\x7f-\xff][a-zA-Z0-9_\x7f-\xff]*';
<a name="line111"></a>        $regex = '/^\\\\?(?:('.$packageRegex.')[.\\\\])?(?:('.$labelRegex.')(?:#|::))?\$?('.$labelRegex.')(?:\(\))?$/';
<a name="line112"></a>		if (preg_match($regex, $this->_link, $matches)) {
<a name="line113"></a>            $packageName = $matches[1];
<a name="line114"></a>            $className = $matches[2];
<a name="line115"></a>            $elementName = $matches[3];
<a name="line116"></a>            
<a name="line117"></a>			if ($packageName) { // get package
<a name="line118"></a>				$package =& $this->_root->packageNamed($packageName);
<a name="line119"></a>				if (!$package) {
<a name="line120"></a>				    return $return;
<a name="line121"></a>				}
<a name="line122"></a>			}
<a name="line123"></a>			if ($className) { // get class
<a name="line124"></a>				if (isset($package)) {
<a name="line125"></a>					$classes =& $package->allClasses();
<a name="line126"></a>				} else {
<a name="line127"></a>					$classes =& $this->_root->classes();
<a name="line128"></a>				}
<a name="line129"></a>                if ($classes) {
<a name="line130"></a>                    foreach ($classes as $key => $class) {
<a name="line131"></a>                        if ($class->name() == $className) {
<a name="line132"></a>                            break;
<a name="line133"></a>                        }
<a name="line134"></a>                    }
<a name="line135"></a>                    $class =& $classes[$key];
<a name="line136"></a>                }
<a name="line137"></a>			}
<a name="line138"></a>			if ($elementName) { // get element
<a name="line139"></a>                if (isset($class)) { // from class
<a name="line140"></a>                    $methods =& $class->methods();
<a name="line141"></a>                    if ($methods) {
<a name="line142"></a>                        foreach($methods as $key => $method) {
<a name="line143"></a>                            if ($method->name() == $elementName) {
<a name="line144"></a>                                $element =& $methods[$key];
<a name="line145"></a>                                break;
<a name="line146"></a>                            }
<a name="line147"></a>                        }
<a name="line148"></a>                    }
<a name="line149"></a>                    if (!isset($element)) {
<a name="line150"></a>                        $fields =& $class->fields();
<a name="line151"></a>                        if ($fields) {
<a name="line152"></a>                            foreach($fields as $key => $field) {
<a name="line153"></a>                                if ($field->name() == $elementName) {
<a name="line154"></a>                                    $element =& $fields[$key];
<a name="line155"></a>                                    break;
<a name="line156"></a>                                }
<a name="line157"></a>                            }
<a name="line158"></a>                        }
<a name="line159"></a>					}
<a name="line160"></a>				} elseif (isset($package)) { // from package
<a name="line161"></a>				    $classes =& $package->allClasses();
<a name="line162"></a>					foreach($classes as $key => $class) {
<a name="line163"></a>						if ($class->name() == $elementName) {
<a name="line164"></a>							$element =& $classes[$key];
<a name="line165"></a>							break;
<a name="line166"></a>						}
<a name="line167"></a>                        $methods =& $class->methods();
<a name="line168"></a>                        if ($methods) {
<a name="line169"></a>                            foreach($methods as $key => $method) {
<a name="line170"></a>                                if ($method->name() == $elementName) {
<a name="line171"></a>                                    $element =& $methods[$key];
<a name="line172"></a>                                    break 2;
<a name="line173"></a>                                }
<a name="line174"></a>                            }
<a name="line175"></a>                        }
<a name="line176"></a>                        if (!isset($element)) {
<a name="line177"></a>                            $fields =& $class->fields();
<a name="line178"></a>                            if ($fields) {
<a name="line179"></a>                                foreach($fields as $key => $field) {
<a name="line180"></a>                                    if ($field->name() == $elementName) {
<a name="line181"></a>                                        $element =& $fields[$key];
<a name="line182"></a>                                        break 2;
<a name="line183"></a>                                    }
<a name="line184"></a>                                }
<a name="line185"></a>                            }
<a name="line186"></a>						}
<a name="line187"></a>					}
<a name="line188"></a>					if (!isset($element)) {
<a name="line189"></a>						$functions =& $package->functions();
<a name="line190"></a>						if ($functions) {
<a name="line191"></a>							foreach($functions as $key => $function) {
<a name="line192"></a>								if ($function->name() == $elementName) {
<a name="line193"></a>									$element =& $functions[$key];
<a name="line194"></a>									break;
<a name="line195"></a>								}
<a name="line196"></a>							}
<a name="line197"></a>						}
<a name="line198"></a>						if (!isset($element)) {
<a name="line199"></a>							$globals =& $package->globals();
<a name="line200"></a>							if ($globals) {
<a name="line201"></a>								foreach($globals as $key => $global) {
<a name="line202"></a>									if ($global->name() == $elementName) {
<a name="line203"></a>										$element =& $globals[$key];
<a name="line204"></a>										break;
<a name="line205"></a>									}
<a name="line206"></a>								}
<a name="line207"></a>							}
<a name="line208"></a>						}
<a name="line209"></a>					}
<a name="line210"></a>				} else { // from anywhere
<a name="line211"></a>					$classes =& $this->_root->classes();
<a name="line212"></a>					if ($classes) {
<a name="line213"></a>						foreach($classes as $key => $class) {
<a name="line214"></a>							if ($class->name() == $elementName) {
<a name="line215"></a>								$element =& $classes[$key];
<a name="line216"></a>								break;
<a name="line217"></a>							}
<a name="line218"></a>                            $methods =& $class->methods();
<a name="line219"></a>                            if ($methods) {
<a name="line220"></a>                                foreach($methods as $key => $method) {
<a name="line221"></a>                                    if ($method->name() == $elementName) {
<a name="line222"></a>                                        $element =& $methods[$key];
<a name="line223"></a>                                        break 2;
<a name="line224"></a>                                    }
<a name="line225"></a>                                }
<a name="line226"></a>                            }
<a name="line227"></a>                            if (!isset($element)) {
<a name="line228"></a>                                $fields =& $class->fields();
<a name="line229"></a>                                if ($fields) {
<a name="line230"></a>                                    foreach($fields as $key => $field) {
<a name="line231"></a>                                        if ($field->name() == $elementName) {
<a name="line232"></a>                                            $element =& $fields[$key];
<a name="line233"></a>                                            break 2;
<a name="line234"></a>                                        }
<a name="line235"></a>                                    }
<a name="line236"></a>                                }
<a name="line237"></a>                            }
<a name="line238"></a>                        }
<a name="line239"></a>					}
<a name="line240"></a>					if (!isset($element)) {
<a name="line241"></a>						$functions =& $this->_root->functions();
<a name="line242"></a>						if ($functions) {
<a name="line243"></a>							foreach($functions as $key => $function) {
<a name="line244"></a>								if ($function->name() == $elementName) {
<a name="line245"></a>									$element =& $functions[$key];
<a name="line246"></a>									break;
<a name="line247"></a>								}
<a name="line248"></a>							}
<a name="line249"></a>						}
<a name="line250"></a>						if (!isset($element)) {
<a name="line251"></a>							$globals =& $this->_root->globals();
<a name="line252"></a>							if ($globals) {
<a name="line253"></a>								foreach($globals as $key => $global) {
<a name="line254"></a>									if ($global->name() == $elementName) {
<a name="line255"></a>										$element =& $globals[$key];
<a name="line256"></a>										break;
<a name="line257"></a>									}
<a name="line258"></a>								}
<a name="line259"></a>							}
<a name="line260"></a>						}
<a name="line261"></a>					}
<a name="line262"></a>				}
<a name="line263"></a>			}
<a name="line264"></a>			$return =& $element;
<a name="line265"></a>		}
<a name="line266"></a>        return $return;
<a name="line267"></a>	}
<a name="line268"></a>	
<a name="line269"></a>	/** Return true if this Taglet is used in constructor documentation.
<a name="line270"></a>     *
<a name="line271"></a>     * @return bool
<a name="line272"></a>     */
<a name="line273"></a>	function inConstructor()
<a name="line274"></a>    {
<a name="line275"></a>		return TRUE;
<a name="line276"></a>	}
<a name="line277"></a>
<a name="line278"></a>	/** Return true if this Taglet is used in field documentation.
<a name="line279"></a>     *
<a name="line280"></a>     * @return bool
<a name="line281"></a>     */
<a name="line282"></a>	function inField()
<a name="line283"></a>    {
<a name="line284"></a>		return TRUE;
<a name="line285"></a>	}
<a name="line286"></a>
<a name="line287"></a>	/** Return true if this Taglet is used in method documentation.          
<a name="line288"></a>     *
<a name="line289"></a>     * @return bool
<a name="line290"></a>     */
<a name="line291"></a>	function inMethod()
<a name="line292"></a>    {
<a name="line293"></a>		return TRUE;
<a name="line294"></a>	}
<a name="line295"></a>
<a name="line296"></a>	/** Return true if this Taglet is used in overview documentation.
<a name="line297"></a>     *
<a name="line298"></a>     * @return bool
<a name="line299"></a>     */
<a name="line300"></a>	function inOverview()
<a name="line301"></a>    {
<a name="line302"></a>		return TRUE;
<a name="line303"></a>	}
<a name="line304"></a>
<a name="line305"></a>	/** Return true if this Taglet is used in package documentation.
<a name="line306"></a>     *
<a name="line307"></a>     * @return bool
<a name="line308"></a>     */
<a name="line309"></a>	function inPackage()
<a name="line310"></a>    {
<a name="line311"></a>		return TRUE;
<a name="line312"></a>	}
<a name="line313"></a>
<a name="line314"></a>	/** Return true if this Taglet is used in class or interface documentation.
<a name="line315"></a>     *
<a name="line316"></a>     * @return bool
<a name="line317"></a>     */
<a name="line318"></a>	function inType()
<a name="line319"></a>    {
<a name="line320"></a>		return TRUE;
<a name="line321"></a>	}
<a name="line322"></a>
<a name="line323"></a>	/** Return true if this Taglet is an inline tag.
<a name="line324"></a>     *
<a name="line325"></a>     * @return bool
<a name="line326"></a>     */
<a name="line327"></a>	function isInlineTag()
<a name="line328"></a>    {
<a name="line329"></a>		return FALSE;
<a name="line330"></a>	}
<a name="line331"></a>
<a name="line332"></a>}
<a name="line333"></a>
<a name="line334"></a>?>
<a name="line335"></a></pre>
<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../overview-files.html">Files</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../todo-list.html">Todo</a></li>
<li><a href="../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../index.html" target="_top">Frames</a>
<a href="../../source/classes/seetag.php.html" target="_top">No frames</a>
</div>
<hr>

<p id="footer">This document was generated by <a href="http://peej.github.com/phpdoctor/">PHPDoctor: The PHP Documentation Creator</a></p>

</body>

</html>